## dbackup
备份数据库服务

## 配置

配置使用TOML格式，示例如下:
```toml
[[PGConfig]]
host = "127.0.0.1"
port = 5432
db = ["test", "postgres"]
username = "abby"
password = "abby"
destination = "D:/backup"
keep = 3
cron = "0 */1 * * * *" # 每分钟的第0秒运行
options = ["-Fc", "--no-owner"]

[[PGConfig]]
host = "127.0.0.1"
port = 5433
db = ["db1", "db2"]
username = "admin"
password = "admin"
destination = "/data/backup"
keep = 10
cron = "0 0 1 * * *" # 每天1点0分0秒运行
options = ["--inserts"]
```

配置中`keep`表示保留最近 N 天， `cron`表示何时执行备份任务，6个`*` 分别表示： 秒, 分, 时, 本月第几天，月，本月第几天，举例如下：


- `33 1 * * * *` 每个小时的 1 分 33 秒执行  
- `*/1 * * * * *` 每秒执行  
- `0 */1 * * * * ` 每分钟执行  
- `23 30 1 * * *`  每天 1 时 30 分 23 秒执行  

更多参考 [这里](https://godoc.org/github.com/robfig/cron)  

## 用法  
1, Windows/Linux下直接运行  
2, Linux下可选择安装为服务 `./dbackup -service install` (以root用户运行)  
  可用参数有 `-service start`, `-service stop`, `-service restart`, `-service install`, `-service uninstall`  
  
程序会读取程序所在目录下的`conf.toml`配置，并在当前目录下创建`log`目录用于记录日志  

## 注意
1，必须保证`pg_dump` 在环境变量中  
2, 程序只会使用必要的参数用于连接数据库，额外的参数可以通过`options`传递  
3, 输出备份文件名为 `db_yyyymmdd-HHMMSS.dump` 且不可配置，存放位置为 `destination/db/db_yyyymmdd-HHMMSS.dump`      
3, windows中程序不能作为服务运行(因为pg_dump找不到pgpass)   

## 示例  

每分钟备份一次，保留最近3分钟的备份  

![example](./example.png)